// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_PIPELINE_H
#define _GSTREAMERMM_PIPELINE_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gstreamermm/bin.h>
#include <gstreamermm/clock.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstPipeline GstPipeline;
typedef struct _GstPipelineClass GstPipelineClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class Pipeline_Class; } // namespace Gst
namespace Gst
{

class Bus;


class Pipeline : public Bin 
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Pipeline CppObjectType;
  typedef Pipeline_Class CppClassType;
  typedef GstPipeline BaseObjectType;
  typedef GstPipelineClass BaseClassType;

private:  friend class Pipeline_Class;
  static CppClassType pipeline_class_;

private:
  // noncopyable
  Pipeline(const Pipeline&);
  Pipeline& operator=(const Pipeline&);

protected:
  explicit Pipeline(const Glib::ConstructParams& construct_params);
  explicit Pipeline(GstPipeline* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Pipeline();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstPipeline*       gobj()       { return reinterpret_cast<GstPipeline*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstPipeline* gobj() const { return reinterpret_cast<GstPipeline*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstPipeline* gobj_copy();

private:


protected:
  Pipeline();

public:
  static Glib::RefPtr<Pipeline> create(const Glib::ustring& name);

  
  Glib::RefPtr<Bus> get_bus();
  
  Glib::RefPtr<const Bus> get_bus() const;
  
  bool set_clock(const Glib::RefPtr<Clock>& clock);
  
  Glib::RefPtr<Clock> get_clock();
  
  Glib::RefPtr<const Clock> get_clock() const;
  
  void use_clock(const Glib::RefPtr<Clock>& clock);
  
  void auto_clock();
  
  void set_new_stream_time(ClockTime time);
  
  ClockTime get_last_stream_time() const;
  
  void set_auto_flush_bus(gboolean auto_flush = true);
  
  bool get_auto_flush_bus() const;
  
  void set_delay(ClockTime delay);
  
  ClockTime get_delay() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} //namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::Pipeline
   */
  Glib::RefPtr<Gst::Pipeline> wrap(GstPipeline* object, bool take_copy = false);
}


#endif /* _GSTREAMERMM_PIPELINE_H */

