// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_PLUGIN_H
#define _GSTREAMERMM_PLUGIN_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gstplugin.h>
#include <gstreamermm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstPlugin GstPlugin;
typedef struct _GstPluginClass GstPluginClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class Plugin_Class; } // namespace Gst
namespace Gst
{

//TODO: Edit references below to use gstreamermm classes/methods

/** Plugin — Container for features loaded from a shared object module.
 * GStreamer is extensible, so Element instances can be loaded at runtime. A
 * plugin system can provide one or more of the basic GStreamer
 * PluginFeature subclasses.
 *
 * A plugin should export a symbol gst_plugin_desc that is a struct of type
 * PluginDesc. the plugin loader will check the version of the core library
 * the plugin was linked against and will create a new Plugin. It will then
 * call the PluginInitFunc function that was provided in the gst_plugin_desc.
 *
 * Once you have a handle to a Plugin (e.g. from the RegistryPool), you can add
 * any object that subclasses PluginFeature.
 *
 * Use find_feature() and feature_list() to find features in a plugin.
 *
 * Usually plugins are always automaticlly loaded so you don't need to call
 * gst_plugin_load() explicitly to bring it into memory. There are options to
 * statically link plugins to an app or even use GStreamer without a plugin
 * repository in which case gst_plugin_load() can be needed to bring the plugin
 * into memory.
 *
 * @newin2p16
 */

class Plugin : public Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Plugin CppObjectType;
  typedef Plugin_Class CppClassType;
  typedef GstPlugin BaseObjectType;
  typedef GstPluginClass BaseClassType;

private:  friend class Plugin_Class;
  static CppClassType plugin_class_;

private:
  // noncopyable
  Plugin(const Plugin&);
  Plugin& operator=(const Plugin&);

protected:
  explicit Plugin(const Glib::ConstructParams& construct_params);
  explicit Plugin(GstPlugin* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Plugin();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstPlugin*       gobj()       { return reinterpret_cast<GstPlugin*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstPlugin* gobj() const { return reinterpret_cast<GstPlugin*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstPlugin* gobj_copy();

private:


public:


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::Plugin
   */
  Glib::RefPtr<Gst::Plugin> wrap(GstPlugin* object, bool take_copy = false);
}


#endif /* _GSTREAMERMM_PLUGIN_H */

